Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.togethersoft.openapi.sci
Interface SciExpressionKind

public interface SciExpressionKind

Defines integer constants used for indentification the kinds of expression.

Author:
  TogetherSoft

Field Summary
`final static int` | `ACCESS` An expression of accessing element's data using `.`
`final static int` | `ADDRESSOF` An expression of giving the memory address in C++ using the address-of operator (&).
`final static int` | `ARRAY_ACCESS` An expression of accessing array's element.
`final static int` | `ARRAY_INITIALIZER` * Array initializer.
`final static int` | `ASSIGN` Assignment expression.
`final static int` | `ASSIGN_BITAND` Assignment &= expression.
`final static int` | `ASSIGN_BITOR` Assignment |= expression.
`final static int` | `ASSIGN_BITXOR` Assignment ^= expression.
`final static int` | `ASSIGN_DIVIDE` Assignment /= expression.
`final static int` | `ASSIGN_MINUS` Assignment -= expression.
`final static int` | `ASSIGN_MULTIPLY` Assignment *= expression.
`final static int` | `ASSIGN_PLUS` Assignment += expression.
`final static int` | `ASSIGN_REMAINDER` Assignment %= expression.
`final static int` | `ASSIGN_SHIFTL` Assignment <<= expression.
`final static int` | `ASSIGN_SHIFTR` Assignment >>= expression.
`final static int` | `ASSIGN_SHIFTUR` Assignment >>>= expression.
`final static int` | `BITWISE_AND` An expression with bitwise operator `&` in Java and C++ or bitwise operator `and` in Delphi.
`final static int` | `BITWISE_NOT` An expression with bitwise NOT operator `~` in Java and C++ or `not` operator in Delphi.
`final static int` | `BITWISE_OR` An expression with bitwise operator `|` in Java and C++ or bitwise operator `or` in Delphi.
`final static int` | `BITWISE_XOR` An expression with bitwise operator `^` in Java and C++ or bitwise operator `xor` in Delphi.
`final static int` | `COMMA_EXPRESSION` An expression of using the comma sign.
`final static int` | `CONDITIONAL` The conditional expression is C++ and Java shorthand for a dual-alternative simple `if-else` statement.
`final static int` | `CONST_CAST` Const cast expression.
`final static int` | `CONSTANT` An expression consisting of a constant.
`final static int` | `CONV_FUNCTION_ID` It's such expression: 'operator' type-specifier-seq *opt Ex: operator int *
`final static int` | `DELETE_EXP` Delete expression.
`final static int` | `DEPRECATED_KIND`
`final static int` | `DIVIDE` An expression with division operator `/` .
`final static int` | `DYNAMIC_CAST` Dynamic cast expression.
`final static int` | `FUNCTION_CALL` An expression of a function call.
`final static int` | `INDIRECTION` An expression of declaring or derefencing a pointer in C++, using a `*` operator, called the indirection (or dereferencing) operator.
`final static int` | `LOGICAL_AND` An expression with logical operator `&&` in Java and C++, or `and`, in Delphi.
`final static int` | `LOGICAL_NOT` An expression with logical NOT operator `!` in Java and C++, or `not` operator in Delphi.
`final static int` | `LOGICAL_OR` An expression with logical operator `||` in Java and C++, or `or`, in Delphi.
`final static int` | `LOGICAL_XOR` An expression with logical operator `^` in Java and C++, or `xor` in Delphi.
`final static int` | `LT_GT` It's such expression : '<...>'
`final static int` | `MINUS` An expression with substraction operator `-` .
`final static int` | `MULTIPLY` An expression with multiplication operator `*` .
`final static int` | `N_A` Expression has this kind if it doesn't fit into other kinds of expressions defined in this interface (cannot be recognized properly in the source code).
`final static int` | `NEW_ARRAY` An expression of creating a new array using `new` operator.
`final static int` | `NEW_EXP` New expression .
`final static int` | `NEW_INSTANCE` An expression of creating a new object instance using `new` operator.
`final static int` | `NEW_TYPE_ID` It's an operand of expression: '::opt new new-placementopt new-type-id new-initializeropt'.
`final static int` | `PARENTHESES` An expression with parentheses `()`.
`final static int` | `PLUS` An expression with addition operator `+` .
`final static int` | `POINTER_ACCESS` An expression of accessing elements' data by pointer (`->`).
`final static int` | `POINTER_ACCESS_REF` An expression of accessing elements' data by pointer reference (`->*`).
`final static int` | `POINTER_TO_MEMBER` An expression of accessing element's member by pointer '.*'.
`final static int` | `POSTDECREMENT` An expression with postdecrement `--` operator.
`final static int` | `POSTINCREMENT` An expression with postincrement `++` operator.
`final static int` | `PREDECREMENT` An expression with predecrement `--` operator.
`final static int` | `PREINCREMENT` An expression with preincrement `++` operator.
`final static int` | `REFERENCE` An expression consisting of a reference to some object.
`final static int` | `REINTERPRET_CAST` Reinterpret cast expression.
`final static int` | `REL_EQUAL` An expression with equality relational operator `==` in Java and C++ or `=` in Delphi.
`final static int` | `REL_GE` An expression with relational operator `>=` (greater than or equal).
`final static int` | `REL_GT` An expression with relational operator `>` (greater than).
`final static int` | `REL_INSTANCEOF` An expression with relational operator `instanceof` (Java only).
`final static int` | `REL_LE` An expression with relational operator `<=` (less than or equal).
`final static int` | `REL_LT` An expression with relational operator `<` (less than).
`final static int` | `REL_NOTEQUAL` An expression with non-equality relational operator `!=` in Java and C++ or `<>` in Delphi.
`final static int` | `REMAINDER` An expression with remainder operator `%` in Java and C++, or `mod` in Delphi.
`final static int` | `SHIFT_LEFT` An expression with bitwise shift operator `<<` in Java and C++ or `shl` in Delhpi.
`final static int` | `SHIFT_RIGHT` An expression with bitwise shift operator `>>` in Java and C++ or `shr` in Delhpi.
`final static int` | `SHIFT_URIGHT` An expression with bitwise shift operator `>>>` (Java only).
`final static int` | `SIGN_MINUS` An expression with unary minus operators `-` .
`final static int` | `SIGN_PLUS` An expression with unary plus operator `+` .
`final static int` | `SIZEOF` An expression of taking the size of expression.
`final static int` | `STATIC_CAST` Static cast expression.
`final static int` | `TEMPLATE_ID` It's a postfix expression : ' template-name <arg-list>'.
`final static int` | `THROW` An expression of throwing an exception.
`final static int` | `TYPE` An expression containing a data type.
`final static int` | `TYPE_CAST` Type casting expression.
`final static int` | `TYPEID` It's expression ( Grammar ): 'typeid ( expression)' Ex: typeid ( int );

Field Detail

### ACCESS

    public final static int ACCESS

  An expression of accessing element's data using `.`. For example:

         int i=someObj.someInt;

  See Also:
    SciMemberAccessExpression

### ADDRESSOF

    public final static int ADDRESSOF

  An expression of giving the memory address in C++ using the address-of operator (&). For example:

       int *iPtr ; // declare a pointer to an integer type
       int i = 2;
       iPtr = &i ; // assign the address of i to the pointer

### ARRAY_ACCESS

    public final static int ARRAY_ACCESS

  An expression of accessing array's element. For example:

       int i=myArray[2];

  Here, `myArray[2]` is expression of this kind.

### ARRAY_INITIALIZER

    public final static int ARRAY_INITIALIZER

  * Array initializer. For example attribute/variable initializer in java : `int a[] = { 1, 2, 3 };`

### ASSIGN

    public final static int ASSIGN

  Assignment expression. `=` in C++ and Java, `:=` in Delphi. For example, in the following lines of code:

       myIntVariable=10;

  `myIntVariable=10` is an expression of this kind.

### ASSIGN_BITAND

    public final static int ASSIGN_BITAND

  Assignment &= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable&=10;

  `myIntVariable&=10` is an expression of this kind.

### ASSIGN_BITOR

    public final static int ASSIGN_BITOR

  Assignment |= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable|=10;

  `myIntVariable|=10` is an expression of this kind.

### ASSIGN_BITXOR

    public final static int ASSIGN_BITXOR

  Assignment ^= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable^=10;

  `myIntVariable^=10` is an expression of this kind.

### ASSIGN_DIVIDE

    public final static int ASSIGN_DIVIDE

  Assignment /= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable/=10;

  `myIntVariable/=10` is an expression of this kind.

### ASSIGN_MINUS

    public final static int ASSIGN_MINUS

  Assignment -= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable-=10;

  `myIntVariable-=10` is an expression of this kind.

### ASSIGN_MULTIPLY

    public final static int ASSIGN_MULTIPLY

  Assignment *= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable*=10;

  `myIntVariable*=10` is an expression of this kind.

### ASSIGN_PLUS

    public final static int ASSIGN_PLUS

  Assignment += expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable+=10;

  `myIntVariable+=10` is an expression of this kind.

### ASSIGN_REMAINDER

    public final static int ASSIGN_REMAINDER

  Assignment %= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable%=10;

  `myIntVariable%=10` is an expression of this kind.

### ASSIGN_SHIFTL

    public final static int ASSIGN_SHIFTL

  Assignment <<= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable<<=10;

  `myIntVariable<<=10` is an expression of this kind.

### ASSIGN_SHIFTR

    public final static int ASSIGN_SHIFTR

  Assignment >>= expression. For Java and C++ only. For example, in the following lines of code:

       myIntVariable>>=10;

  `myIntVariable>>=10` is an expression of this kind.

### ASSIGN_SHIFTUR

    public final static int ASSIGN_SHIFTUR

  Assignment >>>= expression. For Java only. For example, in the following lines of code:

       myIntVariable>>>=10;

  `myIntVariable>>>=10` is an expression of this kind.

### BITWISE_AND

    public final static int BITWISE_AND

  An expression with bitwise operator `&` in Java and C++ or bitwise operator `and` in Delphi. For example:

        int a=5;
        int b=5;
        int c=a&b;

  Here, the expression `a&b` has this kind of expression.

### BITWISE_NOT

    public final static int BITWISE_NOT

  An expression with bitwise NOT operator `~` in Java and C++ or `not` operator in Delphi. For example:

        int i=3;
        int j=~i;

  Here, the expression `j~i` has this kind of expression.

### BITWISE_OR

    public final static int BITWISE_OR

  An expression with bitwise operator `|` in Java and C++ or bitwise operator `or` in Delphi. For example:

        int a=5;
        int b=5;
        int c=a|b;

  Here, the expression `a|b` has this kind of expression.

### BITWISE_XOR

    public final static int BITWISE_XOR

  An expression with bitwise operator `^` in Java and C++ or bitwise operator `xor` in Delphi. For example:

        int a=5;
        int b=5;
        int c=a^b;

  Here, the expression `a^b` has this kind of expression.

### COMMA_EXPRESSION

    public final static int COMMA_EXPRESSION

  An expression of using the comma sign. For example, `exp1, exp2, exp3`.

### CONDITIONAL

    public final static int CONDITIONAL

  The conditional expression is C++ and Java shorthand for a dual-alternative simple `if-else` statement. For example:

       myInt = (someBooleanFlag) ? 5 : 4;

### CONST_CAST

    public final static int CONST_CAST

  Const cast expression. Cpp only.

### CONSTANT

    public final static int CONSTANT

  An expression consisting of a constant. For example, in the following lines:

       int j=10;

  for the variable `j` method `SciVariable.getInitialValue` will return an expression of a this kind.
  See Also:
    SciVariable.getInitialValue()

### CONV_FUNCTION_ID

    public final static int CONV_FUNCTION_ID

  It's such expression: 'operator' type-specifier-seq *opt

  Ex: operator int *

### DELETE_EXP

    public final static int DELETE_EXP

  Delete expression. Cpp only.

### DEPRECATED_KIND

    public final static int DEPRECATED_KIND

### DIVIDE

    public final static int DIVIDE

  An expression with division operator `/` . For example:

        int i=10;
        int k=i/2;

  Here, the expression `i/2` has this kind of expression.

### DYNAMIC_CAST

    public final static int DYNAMIC_CAST

  Dynamic cast expression. Cpp only.

### FUNCTION_CALL

    public final static int FUNCTION_CALL

  An expression of a function call. For example in this source code line:

       someObj.someMethod();

  the `someObj.someMethod()` is an expression of this kind.
  See Also:
    SciFunctionCallExpression

### INDIRECTION

    public final static int INDIRECTION

  An expression of declaring or derefencing a pointer in C++, using a `*` operator, called the indirection (or dereferencing) operator. For example:

       *iPtr = 4 ; // assign the address of i to the pointer

### LOGICAL_AND

    public final static int LOGICAL_AND

  An expression with logical operator `&&` in Java and C++, or `and`, in Delphi. For example:

        if ((someBooleanFlag1)&&(someBooleanFlag2)) {
          ...
        }

  Here, the expression `(someBooleanFlag1)&&(someBooleanFlag2)` has this kind of expression.

### LOGICAL_NOT

    public final static int LOGICAL_NOT

  An expression with logical NOT operator `!` in Java and C++, or `not` operator in Delphi. For example:

       if (!someBooleanFlag) {
         ...
       }

  Here, the expression `!someBooleanFlag` has this kind of expression.

### LOGICAL_OR

    public final static int LOGICAL_OR

  An expression with logical operator `||` in Java and C++, or `or`, in Delphi. For example:

        if ((someBooleanFlag1)||(someBooleanFlag2)) {
          ...
        }

  Here, the expression `(someBooleanFlag1)||(someBooleanFlag2)` has this kind of expression.

### LOGICAL_XOR

    public final static int LOGICAL_XOR

  An expression with logical operator `^` in Java and C++, or `xor` in Delphi. For example:

        if ((someBooleanFlag1)xor(someBooleanFlag2)) then begin end;

  Here, the expression `(someBooleanFlag1)xor(someBooleanFlag2)` has this kind of expression.

### LT_GT

    public final static int LT_GT

  It's such expression : '<...>'

### MINUS

    public final static int MINUS

  An expression with substraction operator `-` . For example:

        int i=10;
        int k=i-2;

  Here, the expression `i-2` has this kind of expression.

### MULTIPLY

    public final static int MULTIPLY

  An expression with multiplication operator `*` . For example:

        int i=10;
        int k=i*2;

  Here, the expression `i*2` has this kind of expression.

### N_A

    public final static int N_A

  Expression has this kind if it doesn't fit into other kinds of expressions defined in this interface (cannot be recognized properly in the source code).

### NEW_ARRAY

    public final static int NEW_ARRAY

  An expression of creating a new array using `new` operator. For example:

       myIntArray = new int[12];

  Here, `new int[12]` is an expression of this kind.

### NEW_EXP

    public final static int NEW_EXP

  New expression . Cpp only.

### NEW_INSTANCE

    public final static int NEW_INSTANCE

  An expression of creating a new object instance using `new` operator. For example:

       CoolButton myCoolButton = new CoolButton("Agent007");

  Here, `new CoolButton("Agent007")` is an expression of this kind.

### NEW_TYPE_ID

    public final static int NEW_TYPE_ID

  It's an operand of expression: '::opt new new-placementopt new-type-id new-initializeropt'. Cpp only.

### PARENTHESES

    public final static int PARENTHESES

  An expression with parentheses `()`. For example:

        i=(2+3)*5;

  Here, the multiplicity expression will have two operands: constant expression for `5` and parentheses expression for `(2+3)`.

### PLUS

    public final static int PLUS

  An expression with addition operator `+` . For example:

        int i=10;
        int k=i+2;

  Here, the expression `i+2` has this kind of expression.

### POINTER_ACCESS

    public final static int POINTER_ACCESS

  An expression of accessing elements' data by pointer (`->`). C++ only.

### POINTER_ACCESS_REF

    public final static int POINTER_ACCESS_REF

  An expression of accessing elements' data by pointer reference (`->*`). C++ only.

### POINTER_TO_MEMBER

    public final static int POINTER_TO_MEMBER

  An expression of accessing element's member by pointer '.*'.

### POSTDECREMENT

    public final static int POSTDECREMENT

  An expression with postdecrement `--` operator. For Java and C++ only. For example:

        int i=3;
        int j=5 * i--; //j is 15, i is 2

  Here, the expression `i--` has this kind of expression.

### POSTINCREMENT

    public final static int POSTINCREMENT

  An expression with postincrement `++` operator. For Java and C++ only. For example:

        int i=3;
        int j=5 * i++; //j is 15, i is 4

  Here, the expression `i++` has this kind of expression.

### PREDECREMENT

    public final static int PREDECREMENT

  An expression with predecrement `--` operator. For Java and C++ only. For example:

        int i=3;
        int j=5 * --i; //j is 10, i is 2

  Here, the expression `--i` has this kind of expression.

### PREINCREMENT

    public final static int PREINCREMENT

  An expression with preincrement `++` operator. For Java and C++ only. For example:

        int i=3;
        int j=5 * ++i; //j is 20, i is 4

  Here, the expression `++i` has this kind of expression.

### REFERENCE

    public final static int REFERENCE

  An expression consisting of a reference to some object. For example,

        runSomeMethod();

  Here, `runSomeMethod()` is an expression of a `FUNCTION_CALL` kind. `getFunction` method applied to this expression will return an expression for `runSomeMethod` of a REFERENCE kind .
  See Also:
    SciFunctionCallExpression.getFunction(), SciReference

### REINTERPRET_CAST

    public final static int REINTERPRET_CAST

  Reinterpret cast expression. Cpp only.

### REL_EQUAL

    public final static int REL_EQUAL

  An expression with equality relational operator `==` in Java and C++ or `=` in Delphi. For example:

         if (5==4) {
         ...
         }

  Here, the expression `5==4` has this kind of expression.

### REL_GE

    public final static int REL_GE

  An expression with relational operator `>=` (greater than or equal). For example:

         if (5>=4) {
         ...
         }

  Here, the expression `5>=4` has this kind of expression.

### REL_GT

    public final static int REL_GT

  An expression with relational operator `>` (greater than). For example:

         if (5>4) {
         ...
         }

  Here, the expression `5>4` has this kind of expression.

### REL_INSTANCEOF

    public final static int REL_INSTANCEOF

  An expression with relational operator `instanceof` (Java only). For example:

         if (someObj1 instanceof someObj2) {
         ...
         }

  Here, the expression `someObj1 instanceof someObj2` has this kind of expression.

### REL_LE

    public final static int REL_LE

  An expression with relational operator `<=` (less than or equal). For example:

         if (5<=4) {
         ...
         }

  Here, the expression `5<=4` has this kind of expression.

### REL_LT

    public final static int REL_LT

  An expression with relational operator `<` (less than). For example:

         if (5<4) {
         ...
         }

  Here, the expression `5<4` has this kind of expression.

### REL_NOTEQUAL

    public final static int REL_NOTEQUAL

  An expression with non-equality relational operator `!=` in Java and C++ or `<>` in Delphi. For example:

         if (5!=4) {
         ...
         }

  Here, the expression `5!=4` has this kind of expression.

### REMAINDER

    public final static int REMAINDER

  An expression with remainder operator `%` in Java and C++, or `mod` in Delphi. For example:

        int i=10;
        int k=i%2;

  Here, the expression `i%2` has this kind of expression.

### SHIFT_LEFT

    public final static int SHIFT_LEFT

  An expression with bitwise shift operator `<<` in Java and C++ or `shl` in Delhpi. For example:

         int i=10;
         int k=i<<2;

  Here, the expression `i<<2` has this kind of expression.

### SHIFT_RIGHT

    public final static int SHIFT_RIGHT

  An expression with bitwise shift operator `>>` in Java and C++ or `shr` in Delhpi. For example:

         int i=10;
         int k=i>>2;

  Here, the expression `i>>2` has this kind of expression.

### SHIFT_URIGHT

    public final static int SHIFT_URIGHT

  An expression with bitwise shift operator `>>>` (Java only). For example:

         int i=10;
         int k=i>>>2;

  Here, the expression `i>>>2` has this kind of expression.

### SIGN_MINUS

    public final static int SIGN_MINUS

  An expression with unary minus operators `-` . For example:

        int i=10;
        int k=-i;

  Here, the expression `k=-i` has this kind of expression.

### SIGN_PLUS

    public final static int SIGN_PLUS

  An expression with unary plus operator `+` . For example:

        int i=10;
        int k=+i;

  Here, the expression `k=+i` has this kind of expression.

### SIZEOF

    public final static int SIZEOF

  An expression of taking the size of expression. Cpp only.

### STATIC_CAST

    public final static int STATIC_CAST

  Static cast expression. Cpp only.

### TEMPLATE_ID

    public final static int TEMPLATE_ID

  It's a postfix expression : ' template-name <arg-list>'.

### THROW

    public final static int THROW

  An expression of throwing an exception. For example:

       throw new MyException1( );

### TYPE

    public final static int TYPE

  An expression containing a data type. For example:

         char c;
         c=(char)System.in.read();

  Here, an expression for `char` (in the second line) has this kind of expression.
  See Also:
    SciType

### TYPE_CAST

    public final static int TYPE_CAST

  Type casting expression. For example, in the following line:

        typeOneObject=(TypeOne)typeTwoObject;

  `typeOneObject=(TypeOne)typeTwoObject` is an expression of `ASSIGN` kind. Method `SciAssignmentExpression.getRValue` will return an expression for `(TypeOne)typeTwoObject` which kind is TYPE_CAST.
  See Also:
    SciAssignmentExpression.getRValue(), SciTypeCastExpression

### TYPEID

    public final static int TYPEID

  It's expression ( Grammar ): 'typeid ( expression)'

  Ex: typeid ( int );

Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD